﻿
'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict On
Option Explicit On

Imports __ExpenseDetail = LightSwitchApplication.ExpenseDetail

Namespace LightSwitchApplication

    #Region "Entities"
    
    ''' <summary>
    ''' No Modeled Description Available
    ''' </summary>
    <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
    Public NotInheritable Partial Class ExpenseDetail
        Inherits Global.Microsoft.LightSwitch.Framework.Base.EntityObject(Of __ExpenseDetail, __ExpenseDetail.DetailsClass)
    
        #Region "Constructors"
    
        ''' <summary>
        ''' Initializes a new instance of the ExpenseDetail entity.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New()
            Me.New(Nothing)
        End Sub
    
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Sub New(entitySet As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __ExpenseDetail))
            MyBase.New(entitySet)
            
            __ExpenseDetail.DetailsClass.Initialize(Me)
        End Sub
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseDetail_Created()
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseDetail_AllowSaveWithErrors(ByRef result As Boolean)
        End Sub
    
        #End Region
    
        #Region "Private Properties"
        
        ''' <summary>
        ''' Gets the Application object for this application.  The Application object provides access to active screens, methods to open screens and access to the current user.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property Application As Global.Microsoft.LightSwitch.IApplication(Of Global.LightSwitchApplication.DataWorkspace)
            Get
                Return Global.LightSwitchApplication.Application.Current
            End Get
        End Property
        
        ''' <summary>
        ''' Gets the containing data workspace.  The data workspace provides access to all data sources in the application.
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Private ReadOnly Property DataWorkspace As Global.LightSwitchApplication.DataWorkspace
            Get
                Return DirectCast(Me.Details.EntitySet.Details.DataService.Details.DataWorkspace, Global.LightSwitchApplication.DataWorkspace)
            End Get
        End Property
        
        #End Region
    
        #Region "Public Properties"
    
        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Id As Integer
            Get
                Return __ExpenseDetail.DetailsClass.GetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.Id)
            End Get
            Set
                __ExpenseDetail.DetailsClass.SetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.Id, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Id_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property RowVersion As Byte()
            Get
                Return __ExpenseDetail.DetailsClass.GetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.RowVersion)
            End Get
            Set
                __ExpenseDetail.DetailsClass.SetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.RowVersion, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub RowVersion_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property ExpenseName As String
            Get
                Return __ExpenseDetail.DetailsClass.GetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseName)
            End Get
            Set
                __ExpenseDetail.DetailsClass.SetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseName, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseName_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseName_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseName_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property Amount As Decimal
            Get
                Return __ExpenseDetail.DetailsClass.GetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.Amount)
            End Get
            Set
                __ExpenseDetail.DetailsClass.SetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.Amount, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Amount_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Amount_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub Amount_Changed()
        End Sub

        ''' <summary>
        ''' No Modeled Description Available
        ''' </summary>
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public Property ExpenseHeader As Global.LightSwitchApplication.ExpenseHeader
            Get
                Return __ExpenseDetail.DetailsClass.GetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader)
            End Get
            Set
                __ExpenseDetail.DetailsClass.SetValue(Me, __ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader, Value)
            End Set
        End Property
        
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseHeader_IsReadOnly(ByRef result As Boolean)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseHeader_Validate(ByVal results As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
        End Sub
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Advanced)> _
        Private Partial Sub ExpenseHeader_Changed()
        End Sub

        #End Region
    
        #Region "Details Class"
    
        <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
        <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
        <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
        <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
        Public NotInheritable Class DetailsClass
            Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of _
                __ExpenseDetail, _
                __ExpenseDetail.DetailsClass, _
                __ExpenseDetail.DetailsClass.IImplementation, _
                __ExpenseDetail.DetailsClass.PropertySet, _
                Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __ExpenseDetail, __ExpenseDetail.DetailsClass), _
                Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __ExpenseDetail, __ExpenseDetail.DetailsClass))
    
            Shared Sub New()
                Dim initializeEntry = __ExpenseDetail.DetailsClass.PropertySetProperties.Id
            End Sub
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private Shared ReadOnly __ExpenseDetailEntry As Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __ExpenseDetail, __ExpenseDetail.DetailsClass).Entry = _
                New Global.Microsoft.LightSwitch.Details.Framework.Base.EntityDetails(Of __ExpenseDetail, __ExpenseDetail.DetailsClass).Entry( _
                    AddressOf __ExpenseDetail.DetailsClass.__ExpenseDetail_CreateNew, _
                    AddressOf __ExpenseDetail.DetailsClass.__ExpenseDetail_Created, _
                    AddressOf __ExpenseDetail.DetailsClass.__ExpenseDetail_AllowSaveWithErrors)
            Private Shared Function __ExpenseDetail_CreateNew(es As Global.Microsoft.LightSwitch.Framework.EntitySet(Of __ExpenseDetail)) As __ExpenseDetail
                Return New __ExpenseDetail(es)
            End Function
            Private Shared Sub __ExpenseDetail_Created(e As __ExpenseDetail)
                e.ExpenseDetail_Created()
            End Sub
            Private Shared Function __ExpenseDetail_AllowSaveWithErrors(e As __ExpenseDetail) As Boolean
                Dim result As Boolean = False
                e.ExpenseDetail_AllowSaveWithErrors(result)
                Return result
            End Function
    
            Public Sub New()
                MyBase.New()
            End Sub
    
            Public ReadOnly Shadows Property Commands As Global.Microsoft.LightSwitch.Details.Framework.EntityCommandSet(Of __ExpenseDetail, __ExpenseDetail.DetailsClass)
                Get
                    Return MyBase.Commands
                End Get
            End Property
    
            Public ReadOnly Shadows Property Methods As Global.Microsoft.LightSwitch.Details.Framework.EntityMethodSet(Of __ExpenseDetail, __ExpenseDetail.DetailsClass)
                Get
                    Return MyBase.Methods
                End Get
            End Property
    
            Public ReadOnly Shadows Property Properties As __ExpenseDetail.DetailsClass.PropertySet
                Get
                    Return MyBase.Properties
                End Get
            End Property
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Public NotInheritable Class PropertySet
                Inherits Global.Microsoft.LightSwitch.Details.Framework.Base.EntityPropertySet(Of __ExpenseDetail, __ExpenseDetail.DetailsClass)
    
                Public Sub New()
                    MyBase.New()
                End Sub
    
                Public ReadOnly Property Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__ExpenseDetail.DetailsClass.PropertySetProperties.Id),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer))
                    End Get
                End Property
                
                Public ReadOnly Property RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte())
                    Get
                        Return TryCast(
                            MyBase.GetItem(__ExpenseDetail.DetailsClass.PropertySetProperties.RowVersion),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte()))
                    End Get
                End Property
                
                Public ReadOnly Property ExpenseName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseName),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String))
                    End Get
                End Property
                
                Public ReadOnly Property Amount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__ExpenseDetail.DetailsClass.PropertySetProperties.Amount),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal))
                    End Get
                End Property
                
                Public ReadOnly Property ExpenseHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader)
                    Get
                        Return TryCast(
                            MyBase.GetItem(__ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader),
                            Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader))
                    End Get
                End Property
                
            End Class
    
            <Global.System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1034:NestedTypesShouldNotBeVisible")> _
            Public Interface IImplementation
                Inherits Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
                Shadows Property Id As Integer
                Shadows Property RowVersion As Byte()
                Shadows Property ExpenseName As String
                Shadows Property Amount As Decimal
                Shadows Property ExpenseHeader As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
    
            End Interface
    
            <Global.System.ComponentModel.EditorBrowsable(Global.System.ComponentModel.EditorBrowsableState.Never)> _
            <Global.System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.LightSwitch.BuildTasks.CodeGen", "11.0.0.0")> _
            <Global.System.Diagnostics.DebuggerNonUserCodeAttribute()> _
            Friend Class PropertySetProperties
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer).Entry( _
                        "Id", _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_Stub, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_ComputeIsReadOnly, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_Validate, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_GetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_SetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Id_OnValueChanged)
                Private Shared Sub _Id_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __ExpenseDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer).Data), d As __ExpenseDetail.DetailsClass, sf As Object)
                    c(d, d._Id, sf)
                End Sub
                Private Shared Function _Id_ComputeIsReadOnly(e As __ExpenseDetail) As Boolean
                    Dim result As Boolean = False
                    e.Id_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Id_Validate(e As __ExpenseDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Id_Validate(r)
                End Sub
                Private Shared Function _Id_GetImplementationValue(d As __ExpenseDetail.DetailsClass) As Integer
                    Return d.ImplementationEntity.Id
                End Function
                Private Shared Sub _Id_SetImplementationValue(d As __ExpenseDetail.DetailsClass, v As Integer)
                    d.ImplementationEntity.Id = v
                End Sub
                Private Shared Sub _Id_OnValueChanged(e As __ExpenseDetail)
                    e.Id_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte()).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte()).Entry( _
                        "RowVersion", _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_Stub, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_ComputeIsReadOnly, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_Validate, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_GetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_SetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._RowVersion_OnValueChanged)
                Private Shared Sub _RowVersion_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __ExpenseDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte()).Data), d As __ExpenseDetail.DetailsClass, sf As Object)
                    c(d, d._RowVersion, sf)
                End Sub
                Private Shared Function _RowVersion_ComputeIsReadOnly(e As __ExpenseDetail) As Boolean
                    Dim result As Boolean = False
                    e.RowVersion_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _RowVersion_Validate(e As __ExpenseDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.RowVersion_Validate(r)
                End Sub
                Private Shared Function _RowVersion_GetImplementationValue(d As __ExpenseDetail.DetailsClass) As Byte()
                    Return d.ImplementationEntity.RowVersion
                End Function
                Private Shared Sub _RowVersion_SetImplementationValue(d As __ExpenseDetail.DetailsClass, v As Byte())
                    d.ImplementationEntity.RowVersion = v
                End Sub
                Private Shared Sub _RowVersion_OnValueChanged(e As __ExpenseDetail)
                    e.RowVersion_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly ExpenseName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String).Entry( _
                        "ExpenseName", _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_Stub, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_ComputeIsReadOnly, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_Validate, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_GetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_SetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseName_OnValueChanged)
                Private Shared Sub _ExpenseName_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __ExpenseDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String).Data), d As __ExpenseDetail.DetailsClass, sf As Object)
                    c(d, d._ExpenseName, sf)
                End Sub
                Private Shared Function _ExpenseName_ComputeIsReadOnly(e As __ExpenseDetail) As Boolean
                    Dim result As Boolean = False
                    e.ExpenseName_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _ExpenseName_Validate(e As __ExpenseDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.ExpenseName_Validate(r)
                End Sub
                Private Shared Function _ExpenseName_GetImplementationValue(d As __ExpenseDetail.DetailsClass) As String
                    Return d.ImplementationEntity.ExpenseName
                End Function
                Private Shared Sub _ExpenseName_SetImplementationValue(d As __ExpenseDetail.DetailsClass, v As String)
                    d.ImplementationEntity.ExpenseName = v
                End Sub
                Private Shared Sub _ExpenseName_OnValueChanged(e As __ExpenseDetail)
                    e.ExpenseName_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly Amount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal).Entry( _
                        "Amount", _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_Stub, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_ComputeIsReadOnly, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_Validate, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_GetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_SetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._Amount_OnValueChanged)
                Private Shared Sub _Amount_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __ExpenseDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal).Data), d As __ExpenseDetail.DetailsClass, sf As Object)
                    c(d, d._Amount, sf)
                End Sub
                Private Shared Function _Amount_ComputeIsReadOnly(e As __ExpenseDetail) As Boolean
                    Dim result As Boolean = False
                    e.Amount_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _Amount_Validate(e As __ExpenseDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.Amount_Validate(r)
                End Sub
                Private Shared Function _Amount_GetImplementationValue(d As __ExpenseDetail.DetailsClass) As Decimal
                    Return d.ImplementationEntity.Amount
                End Function
                Private Shared Sub _Amount_SetImplementationValue(d As __ExpenseDetail.DetailsClass, v As Decimal)
                    d.ImplementationEntity.Amount = v
                End Sub
                Private Shared Sub _Amount_OnValueChanged(e As __ExpenseDetail)
                    e.Amount_Changed()
                End Sub
    
                <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
                Public Shared ReadOnly ExpenseHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader).Entry = _
                    New Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader).Entry( _
                        "ExpenseHeader", _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_Stub, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_ComputeIsReadOnly, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_Validate, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_GetCoreImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_GetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_SetImplementationValue, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_Refresh, _
                        AddressOf __ExpenseDetail.DetailsClass.PropertySetProperties._ExpenseHeader_OnValueChanged)
                Private Shared Sub _ExpenseHeader_Stub(c As Global.Microsoft.LightSwitch.Details.Framework.Base.DetailsCallback(Of __ExpenseDetail.DetailsClass, Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader).Data), d As __ExpenseDetail.DetailsClass, sf As Object)
                    c(d, d._ExpenseHeader, sf)
                End Sub
                Private Shared Function _ExpenseHeader_ComputeIsReadOnly(e As __ExpenseDetail) As Boolean
                    Dim result As Boolean = False
                    e.ExpenseHeader_IsReadOnly(result)
                    Return result
                End Function
                Private Shared Sub _ExpenseHeader_Validate(e As __ExpenseDetail, r As Global.Microsoft.LightSwitch.EntityValidationResultsBuilder)
                    e.ExpenseHeader_Validate(r)
                End Sub
                Private Shared Function _ExpenseHeader_GetCoreImplementationValue(d as __ExpenseDetail.DetailsClass) As Global.Microsoft.LightSwitch.Internal.IEntityImplementation
                    Return d.ImplementationEntity.ExpenseHeader
                End Function
                Private Shared Function _ExpenseHeader_GetImplementationValue(d as __ExpenseDetail.DetailsClass) As Global.LightSwitchApplication.ExpenseHeader
                    Return d.GetImplementationValue(Of Global.LightSwitchApplication.ExpenseHeader, Global.LightSwitchApplication.ExpenseHeader.DetailsClass)(__ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader, d._ExpenseHeader)
                End Function
                Private Shared Sub _ExpenseHeader_SetImplementationValue(d As __ExpenseDetail.DetailsClass, v As Global.LightSwitchApplication.ExpenseHeader)
                    d.SetImplementationValue(__ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader, d._ExpenseHeader, Sub(i, ev) i.ExpenseHeader = ev, v)
                End Sub
                Private Shared Sub _ExpenseHeader_Refresh(d As __ExpenseDetail.DetailsClass)
                    d.RefreshNavigationProperty(__ExpenseDetail.DetailsClass.PropertySetProperties.ExpenseHeader, d._ExpenseHeader)
                End Sub
                Private Shared Sub _ExpenseHeader_OnValueChanged(e As __ExpenseDetail)
                    e.ExpenseHeader_Changed()
                End Sub
    
            End Class
    
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Id As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Integer).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _RowVersion As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Byte()).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _ExpenseName As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, String).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _Amount As Global.Microsoft.LightSwitch.Details.Framework.EntityStorageProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Decimal).Data
            
            <Global.System.Diagnostics.DebuggerBrowsable(Global.System.Diagnostics.DebuggerBrowsableState.Never)> _
            Private _ExpenseHeader As Global.Microsoft.LightSwitch.Details.Framework.EntityReferenceProperty(Of __ExpenseDetail, __ExpenseDetail.DetailsClass, Global.LightSwitchApplication.ExpenseHeader).Data
            
        End Class
    
        #End Region
    
    End Class
    
    #End Region
End Namespace
